Open CASCADE Technology: GeomFill_UniformSection Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
GeomFill_UniformSection Class Reference

Define an Constant Section Law. More...

`#include <GeomFill_UniformSection.hxx>`

Inheritance diagram for GeomFill_UniformSection:
[legend]

## Public Member Functions
| GeomFill_UniformSection (const Handle< Geom_Curve > &C, const Standard_Real FirstParameter=0.0, const Standard_Real LastParameter=1.0)
| Make an constant Law with C. [First, Last] define law definition domain. More...
virtual Standard_Boolean | D0 (const Standard_Real Param, TColgp_Array1OfPnt &Poles, TColStd_Array1OfReal &Weigths)
| compute the section for v = param More...
virtual Standard_Boolean | D1 (const Standard_Real Param, TColgp_Array1OfPnt &Poles, TColgp_Array1OfVec &DPoles, TColStd_Array1OfReal &Weigths, TColStd_Array1OfReal &DWeigths)
| compute the first derivative in v direction of the section for v = param Warning : It used only for C1 or C2 aproximation More...
virtual Standard_Boolean | D2 (const Standard_Real Param, TColgp_Array1OfPnt &Poles, TColgp_Array1OfVec &DPoles, TColgp_Array1OfVec &D2Poles, TColStd_Array1OfReal &Weigths, TColStd_Array1OfReal &DWeigths, TColStd_Array1OfReal &D2Weigths)
| compute the second derivative in v direction of the section for v = param Warning : It used only for C2 aproximation More...
virtual Handle < Geom_BSplineSurface > | BSplineSurface () const
| give if possible an bspline Surface, like iso-v are the section. If it is not possible this methode have to get an Null Surface. Is it the default implementation. More...
virtual void | SectionShape (Standard_Integer &NbPoles, Standard_Integer &NbKnots, Standard_Integer &Degree) const
| get the format of an section More...
virtual void | Knots (TColStd_Array1OfReal &TKnots) const
| get the Knots of the section More...
virtual void | Mults (TColStd_Array1OfInteger &TMults) const
| get the Multplicities of the section More...
virtual Standard_Boolean | IsRational () const
| Returns if the sections are rationnal or not. More...
virtual Standard_Boolean | IsUPeriodic () const
| Returns if the sections are periodic or not. More...
virtual Standard_Boolean | IsVPeriodic () const
| Returns if the law isperiodic or not. More...
virtual Standard_Integer | NbIntervals (const GeomAbs_Shape S) const
| Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S> More...
virtual void | Intervals (TColStd_Array1OfReal &T, const GeomAbs_Shape S) const
| Stores in <T> the parameters bounding the intervals of continuity <S>. More...
virtual void | SetInterval (const Standard_Real First, const Standard_Real Last)
| Sets the bounds of the parametric interval on the function This determines the derivatives in these values if the function is not Cn. More...
virtual void | GetInterval (Standard_Real &First, Standard_Real &Last) const
| Gets the bounds of the parametric interval on the function. More...
virtual void | GetDomain (Standard_Real &First, Standard_Real &Last) const
| Gets the bounds of the function parametric domain. Warning: This domain it is not modified by the SetValue method. More...
virtual void | GetTolerance (const Standard_Real BoundTol, const Standard_Real SurfTol, const Standard_Real AngleTol, TColStd_Array1OfReal &Tol3d) const
| Returns the tolerances associated at each poles to reach in approximation, to satisfy: BoundTol error at the Boundary AngleTol tangent error at the Boundary (in radian) SurfTol error inside the surface. More...
virtual gp_Pnt | BarycentreOfSurf () const
| Get the barycentre of Surface. An very poor estimation is sufficent. This information is usefull to perform well conditioned rational approximation. Warning: Used only if <me> IsRational. More...
virtual Standard_Real | MaximalSection () const
| Returns the length of the greater section. This information is usefull to G1's control. Warning: With an little value, approximation can be slower. More...
virtual void | GetMinimalWeight (TColStd_Array1OfReal &Weigths) const
| Compute the minimal value of weight for each poles in all sections. This information is usefull to control error in rational approximation. Warning: Used only if <me> IsRational. More...
virtual Standard_Boolean | IsConstant (Standard_Real &Error) const
| return True More...
virtual Handle< Geom_Curve > | ConstantSection () const
| Return the constant Section if <me> IsConstant. More...
Public Member Functions inherited from GeomFill_SectionLaw
virtual void | SetTolerance (const Standard_Real Tol3d, const Standard_Real Tol2d)
| Is usefull, if (me) have to run numerical algorithm to perform D0, D1 or D2 The default implementation make nothing. More...
virtual Standard_Boolean | IsConicalLaw (Standard_Real &Error) const
| Returns True if all section are circle, with same plane,same center and linear radius evolution Return False by Default. More...
virtual Handle< Geom_Curve > | CirclSection (const Standard_Real Param) const
| Return the circle section at parameter , if <me> a IsConicalLaw. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Define an Constant Section Law.

## Constructor & Destructor Documentation

GeomFill_UniformSection::GeomFill_UniformSection | ( | const Handle< Geom_Curve > & | C,
|  | const Standard_Real | FirstParameter = `0.0`,
|  | const Standard_Real | LastParameter = `1.0`
| ) |  |

Make an constant Law with C. [First, Last] define law definition domain.

## Member Function Documentation

virtual gp_Pnt GeomFill_UniformSection::BarycentreOfSurf | ( |  | ) | const
| virtual

Get the barycentre of Surface. An very poor estimation is sufficent. This information is usefull to perform well conditioned rational approximation. Warning: Used only if <me> IsRational.

Reimplemented from GeomFill_SectionLaw.

virtual Handle< Geom_BSplineSurface > GeomFill_UniformSection::BSplineSurface | ( |  | ) | const
| virtual

give if possible an bspline Surface, like iso-v are the section. If it is not possible this methode have to get an Null Surface. Is it the default implementation.

Reimplemented from GeomFill_SectionLaw.

virtual Handle< Geom_Curve > GeomFill_UniformSection::ConstantSection | ( |  | ) | const
| virtual

Return the constant Section if <me> IsConstant.

Reimplemented from GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::D0 | ( | const Standard_Real | Param,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColStd_Array1OfReal & | Weigths
| ) |  |
| virtual

compute the section for v = param

Implements GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::D1 | ( | const Standard_Real | Param,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColgp_Array1OfVec & | DPoles,
|  | TColStd_Array1OfReal & | Weigths,
|  | TColStd_Array1OfReal & | DWeigths
| ) |  |
| virtual

compute the first derivative in v direction of the section for v = param Warning : It used only for C1 or C2 aproximation

Reimplemented from GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::D2 | ( | const Standard_Real | Param,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColgp_Array1OfVec & | DPoles,
|  | TColgp_Array1OfVec & | D2Poles,
|  | TColStd_Array1OfReal & | Weigths,
|  | TColStd_Array1OfReal & | DWeigths,
|  | TColStd_Array1OfReal & | D2Weigths
| ) |  |
| virtual

compute the second derivative in v direction of the section for v = param Warning : It used only for C2 aproximation

Reimplemented from GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::GetDomain | ( | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  | const
| virtual

Gets the bounds of the function parametric domain. Warning: This domain it is not modified by the SetValue method.

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::GetInterval | ( | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  | const
| virtual

Gets the bounds of the parametric interval on the function.

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::GetMinimalWeight | ( | TColStd_Array1OfReal & | Weigths | ) | const
| virtual

Compute the minimal value of weight for each poles in all sections. This information is usefull to control error in rational approximation. Warning: Used only if <me> IsRational.

Reimplemented from GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::GetTolerance | ( | const Standard_Real | BoundTol,
|  | const Standard_Real | SurfTol,
|  | const Standard_Real | AngleTol,
|  | TColStd_Array1OfReal & | Tol3d
| ) |  | const
| virtual

Returns the tolerances associated at each poles to reach in approximation, to satisfy: BoundTol error at the Boundary AngleTol tangent error at the Boundary (in radian) SurfTol error inside the surface.

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::Intervals | ( | TColStd_Array1OfReal & | T,
|  | const GeomAbs_Shape | S
| ) |  | const
| virtual

Stores in <T> the parameters bounding the intervals of continuity <S>.

The array must provide enough room to accomodate for the parameters. i.e. T.Length() > NbIntervals()

Implements GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::IsConstant | ( | Standard_Real & | Error | ) | const
| virtual

return True

Reimplemented from GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::IsRational | ( |  | ) | const
| virtual

Returns if the sections are rationnal or not.

Implements GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::IsUPeriodic | ( |  | ) | const
| virtual

Returns if the sections are periodic or not.

Implements GeomFill_SectionLaw.

virtual Standard_Boolean GeomFill_UniformSection::IsVPeriodic | ( |  | ) | const
| virtual

Returns if the law isperiodic or not.

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::Knots | ( | TColStd_Array1OfReal & | TKnots | ) | const
| virtual

get the Knots of the section

Implements GeomFill_SectionLaw.

virtual Standard_Real GeomFill_UniformSection::MaximalSection | ( |  | ) | const
| virtual

Returns the length of the greater section. This information is usefull to G1's control. Warning: With an little value, approximation can be slower.

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::Mults | ( | TColStd_Array1OfInteger & | TMults | ) | const
| virtual

get the Multplicities of the section

Implements GeomFill_SectionLaw.

virtual Standard_Integer GeomFill_UniformSection::NbIntervals | ( | const GeomAbs_Shape | S | ) | const
| virtual

Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S>

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::SectionShape | ( | Standard_Integer & | NbPoles,
|  | Standard_Integer & | NbKnots,
|  | Standard_Integer & | Degree
| ) |  | const
| virtual

get the format of an section

Implements GeomFill_SectionLaw.

virtual void GeomFill_UniformSection::SetInterval | ( | const Standard_Real | First,
|  | const Standard_Real | Last
| ) |  |
| virtual

Sets the bounds of the parametric interval on the function This determines the derivatives in these values if the function is not Cn.

Implements GeomFill_SectionLaw.

The documentation for this class was generated from the following file:

- GeomFill_UniformSection.hxx